package org.xdoclet.plugin.ejb.qtags;

public class EjbBeanTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbBeanTag {
    public static final String NAME = "ejb.bean";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"impl-class-name",
		"acknowledge-mode",
		"cmp-version",
		"description",
		"destination-type",
		"display-name",
		"generate",
		"large-icon",
		"local-business-interface",
		"local-jndi-name",
		"message-selector",
		"name",
		"primkey-field",
		"reentrant",
		"remote-business-interface",
		"schema",
		"small-icon",
		"subscription-durability",
		"transaction-type",
		"type",
		"use-soft-locking",
		"destination-link",
		"destination-jndi-name",
		"connection-factory-jndi-name",
		"messaging-type",
		"jndi-name",
		"view-type",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbBeanTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbBeanTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getImplClassName() {
		boolean required = false;
        String result = getNamedParameter("impl-class-name");
        if(required && result == null) {
            bomb("impl-class-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAcknowledgeMode() {
		boolean required = false;
        String result = getNamedParameter("acknowledge-mode");
        if(required && result == null) {
            bomb("acknowledge-mode=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Auto-acknowledge")|| result.equals("Dups-ok-acknowledge")) ) {
	                // todo we should say what file and line number too
	                bomb("acknowledge-mode=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getCmpVersion() {
		boolean required = false;
        String result = getNamedParameter("cmp-version");
        if(required && result == null) {
            bomb("cmp-version=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("1.x")|| result.equals("2.x")) ) {
	                // todo we should say what file and line number too
	                bomb("cmp-version=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDestinationType() {
		boolean required = false;
        String result = getNamedParameter("destination-type");
        if(required && result == null) {
            bomb("destination-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("javax.jms.Queue")|| result.equals("javax.jms.Topic")) ) {
	                // todo we should say what file and line number too
	                bomb("destination-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDisplayName() {
		boolean required = false;
        String result = getNamedParameter("display-name");
        if(required && result == null) {
            bomb("display-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isGenerate() {
		boolean required = false;
        String result = getNamedParameter("generate");
        if(required && result == null) {
            bomb("generate=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getLargeIcon() {
		boolean required = false;
        String result = getNamedParameter("large-icon");
        if(required && result == null) {
            bomb("large-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLocalBusinessInterface() {
		boolean required = false;
        String result = getNamedParameter("local-business-interface");
        if(required && result == null) {
            bomb("local-business-interface=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLocalJndiName() {
		boolean required = false;
        String result = getNamedParameter("local-jndi-name");
        if(required && result == null) {
            bomb("local-jndi-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMessageSelector() {
		boolean required = false;
        String result = getNamedParameter("message-selector");
        if(required && result == null) {
            bomb("message-selector=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getName_() {
		boolean required = true;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPrimkeyField() {
		boolean required = false;
        String result = getNamedParameter("primkey-field");
        if(required && result == null) {
            bomb("primkey-field=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isReentrant() {
		boolean required = false;
        String result = getNamedParameter("reentrant");
        if(required && result == null) {
            bomb("reentrant=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getRemoteBusinessInterface() {
		boolean required = false;
        String result = getNamedParameter("remote-business-interface");
        if(required && result == null) {
            bomb("remote-business-interface=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSchema() {
		boolean required = false;
        String result = getNamedParameter("schema");
        if(required && result == null) {
            bomb("schema=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSmallIcon() {
		boolean required = false;
        String result = getNamedParameter("small-icon");
        if(required && result == null) {
            bomb("small-icon=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSubscriptionDurability() {
		boolean required = false;
        String result = getNamedParameter("subscription-durability");
        if(required && result == null) {
            bomb("subscription-durability=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Durable")|| result.equals("NonDurable")) ) {
	                // todo we should say what file and line number too
	                bomb("subscription-durability=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTransactionType() {
		boolean required = false;
        String result = getNamedParameter("transaction-type");
        if(required && result == null) {
            bomb("transaction-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "Container";
        }

		if (result != null) {
	            if( !(false || result.equals("Container")|| result.equals("Bean")) ) {
	                // todo we should say what file and line number too
	                bomb("transaction-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getType() {
		boolean required = false;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("CMP")|| result.equals("BMP")|| result.equals("Stateless")|| result.equals("Stateful")) ) {
	                // todo we should say what file and line number too
	                bomb("type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isUseSoftLocking() {
		boolean required = false;
        String result = getNamedParameter("use-soft-locking");
        if(required && result == null) {
            bomb("use-soft-locking=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getDestinationLink() {
		boolean required = false;
        String result = getNamedParameter("destination-link");
        if(required && result == null) {
            bomb("destination-link=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDestinationJndiName() {
		boolean required = false;
        String result = getNamedParameter("destination-jndi-name");
        if(required && result == null) {
            bomb("destination-jndi-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getConnectionFactoryJndiName() {
		boolean required = false;
        String result = getNamedParameter("connection-factory-jndi-name");
        if(required && result == null) {
            bomb("connection-factory-jndi-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMessagingType() {
		boolean required = false;
        String result = getNamedParameter("messaging-type");
        if(required && result == null) {
            bomb("messaging-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "javax.jms.MessageListener";
        }

		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getJndiName() {
		boolean required = false;
        String result = getNamedParameter("jndi-name");
        if(required && result == null) {
            bomb("jndi-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getViewType() {
		boolean required = false;
        String result = getNamedParameter("view-type");
        if(required && result == null) {
            bomb("view-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("local")|| result.equals("remote")|| result.equals("both")|| result.equals("service-endpoint")|| result.equals("remote-service-endpoint")|| result.equals("local-service-endpoint")|| result.equals("all")) ) {
	                // todo we should say what file and line number too
	                bomb("view-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getImplClassName();
        getAcknowledgeMode();
        getCmpVersion();
        getDescription();
        getDestinationType();
        getDisplayName();
        isGenerate();
        getLargeIcon();
        getLocalBusinessInterface();
        getLocalJndiName();
        getMessageSelector();
        getName_();
        getPrimkeyField();
        isReentrant();
        getRemoteBusinessInterface();
        getSchema();
        getSmallIcon();
        getSubscriptionDurability();
        getTransactionType();
        getType();
        isUseSoftLocking();
        getDestinationLink();
        getDestinationJndiName();
        getConnectionFactoryJndiName();
        getMessagingType();
        getJndiName();
        getViewType();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}