package org.xdoclet.plugin.ejb.qtags;

public class EjbEjbExternalRefTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbEjbExternalRefTag {
    public static final String NAME = "ejb.ejb-external-ref";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"business",
		"home",
		"link",
		"ref-name",
		"type",
		"view-type",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbEjbExternalRefTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbEjbExternalRefTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getBusiness() {
		boolean required = true;
        String result = getNamedParameter("business");
        if(required && result == null) {
            bomb("business=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getHome() {
		boolean required = true;
        String result = getNamedParameter("home");
        if(required && result == null) {
            bomb("home=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLink() {
		boolean required = false;
        String result = getNamedParameter("link");
        if(required && result == null) {
            bomb("link=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRefName() {
		boolean required = false;
        String result = getNamedParameter("ref-name");
        if(required && result == null) {
            bomb("ref-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getType() {
		boolean required = true;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Entity")|| result.equals("Session")) ) {
	                // todo we should say what file and line number too
	                bomb("type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getViewType() {
		boolean required = false;
        String result = getNamedParameter("view-type");
        if(required && result == null) {
            bomb("view-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "remote";
        }

		if (result != null) {
	            if( !(false || result.equals("local")|| result.equals("remote")) ) {
	                // todo we should say what file and line number too
	                bomb("view-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getBusiness();
        getHome();
        getLink();
        getRefName();
        getType();
        getViewType();
    }

    public void validateModel() {
        // check uniqueness
    }
}