package org.xdoclet.plugin.ejb.qtags;

public class EjbFacadeMethodTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbFacadeMethodTag {
    public static final String NAME = "ejb.facade-method";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"cache",
		"immutable",
		"invalidate",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbFacadeMethodTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbFacadeMethodTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public boolean isCache() {
		boolean required = false;
        String result = getNamedParameter("cache");
        if(required && result == null) {
            bomb("cache=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isImmutable() {
		boolean required = false;
        String result = getNamedParameter("immutable");
        if(required && result == null) {
            bomb("immutable=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public boolean isInvalidate() {
		boolean required = false;
        String result = getNamedParameter("invalidate");
        if(required && result == null) {
            bomb("invalidate=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        isCache();
        isImmutable();
        isInvalidate();
    }

    public void validateModel() {
        // check uniqueness
    }
}