package org.xdoclet.plugin.ejb.qtags;

public class EjbFinderTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbFinderTag {
    public static final String NAME = "ejb.finder";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"description",
		"method-intf",
		"query",
		"result-type-mapping",
		"signature",
		"transaction-type",
		"view-type",
		"max-elements",
		"unchecked",
		"role-names",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbFinderTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbFinderTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMethodIntf() {
		boolean required = false;
        String result = getNamedParameter("method-intf");
        if(required && result == null) {
            bomb("method-intf=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Home")|| result.equals("LocalHome")) ) {
	                // todo we should say what file and line number too
	                bomb("method-intf=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getQuery() {
		boolean required = false;
        String result = getNamedParameter("query");
        if(required && result == null) {
            bomb("query=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getResultTypeMapping() {
		boolean required = false;
        String result = getNamedParameter("result-type-mapping");
        if(required && result == null) {
            bomb("result-type-mapping=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Local")|| result.equals("Remote")) ) {
	                // todo we should say what file and line number too
	                bomb("result-type-mapping=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getSignature() {
		boolean required = true;
        String result = getNamedParameter("signature");
        if(required && result == null) {
            bomb("signature=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getTransactionType() {
		boolean required = false;
        String result = getNamedParameter("transaction-type");
        if(required && result == null) {
            bomb("transaction-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("NotSupported")|| result.equals("Supports")|| result.equals("Required")|| result.equals("RequiresNew")|| result.equals("Mandatory")|| result.equals("Never")) ) {
	                // todo we should say what file and line number too
	                bomb("transaction-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getViewType() {
		boolean required = false;
        String result = getNamedParameter("view-type");
        if(required && result == null) {
            bomb("view-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "both";
        }

		if (result != null) {
	            if( !(false || result.equals("local")|| result.equals("remote")|| result.equals("both")) ) {
	                // todo we should say what file and line number too
	                bomb("view-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.Integer getMaxElements() {
		boolean required = false;
        String result = getNamedParameter("max-elements");
        if(required && result == null) {
            bomb("max-elements=\"???\" must be specified.");
        }

		java.lang.Integer retVal = null;


		if (result != null) {
	            try {
	                retVal = Integer.decode(result);
	            } catch(NumberFormatException nfe) {
	                bomb("max-elements=\"" + result + "\" is not valid integer");
	                throw nfe;
	            }
		}
		
		return retVal;
    }
    public boolean isUnchecked() {
		boolean required = false;
        String result = getNamedParameter("unchecked");
        if(required && result == null) {
            bomb("unchecked=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String[] getRoleNames() {
		boolean required = false;
        String result = getNamedParameter("role-names");
        if(required && result == null) {
            bomb("role-names=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;


		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getDescription();
        getMethodIntf();
        getQuery();
        getResultTypeMapping();
        getSignature();
        getTransactionType();
        getViewType();
        getMaxElements();
        isUnchecked();
        getRoleNames();
    }

    public void validateModel() {
        // check uniqueness
    }
}