package org.xdoclet.plugin.ejb.qtags;

public class EjbInterfaceTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbInterfaceTag {
    public static final String NAME = "ejb.interface";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"generate",
		"service-endpoint-extends",
		"service-endpoint-class",
		"service-endpoint-pattern",
		"service-endpoint-package",
		"extends",
		"local-class",
		"local-extends",
		"local-package",
		"local-pattern",
		"remote-class",
		"remote-package",
		"remote-pattern",
		"pattern",
		"package",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbInterfaceTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbInterfaceTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String[] getGenerate() {
		boolean required = false;
        String result = getNamedParameter("generate");
        if(required && result == null) {
            bomb("generate=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;

        if(result == null) {
            result = "local,remote";
        }

		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            if( !(false || token.equals("local")|| token.equals("remote")|| token.equals("service-endpoint")) ) {
	                // todo we should say what file and line number too
	                bomb("generate=\"" + token + "\" is an invalid parameter value.");
	            }
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }
    public java.lang.String[] getServiceEndpointExtends() {
		boolean required = false;
        String result = getNamedParameter("service-endpoint-extends");
        if(required && result == null) {
            bomb("service-endpoint-extends=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;


		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }
    public java.lang.String getServiceEndpointClass() {
		boolean required = false;
        String result = getNamedParameter("service-endpoint-class");
        if(required && result == null) {
            bomb("service-endpoint-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getServiceEndpointPattern() {
		boolean required = false;
        String result = getNamedParameter("service-endpoint-pattern");
        if(required && result == null) {
            bomb("service-endpoint-pattern=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getServiceEndpointPackage() {
		boolean required = false;
        String result = getNamedParameter("service-endpoint-package");
        if(required && result == null) {
            bomb("service-endpoint-package=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String[] getExtends() {
		boolean required = false;
        String result = getNamedParameter("extends");
        if(required && result == null) {
            bomb("extends=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;


		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }
    public java.lang.String getLocalClass() {
		boolean required = false;
        String result = getNamedParameter("local-class");
        if(required && result == null) {
            bomb("local-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String[] getLocalExtends() {
		boolean required = false;
        String result = getNamedParameter("local-extends");
        if(required && result == null) {
            bomb("local-extends=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;


		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }
    public java.lang.String getLocalPackage() {
		boolean required = false;
        String result = getNamedParameter("local-package");
        if(required && result == null) {
            bomb("local-package=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLocalPattern() {
		boolean required = false;
        String result = getNamedParameter("local-pattern");
        if(required && result == null) {
            bomb("local-pattern=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRemoteClass() {
		boolean required = false;
        String result = getNamedParameter("remote-class");
        if(required && result == null) {
            bomb("remote-class=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRemotePackage() {
		boolean required = false;
        String result = getNamedParameter("remote-package");
        if(required && result == null) {
            bomb("remote-package=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getRemotePattern() {
		boolean required = false;
        String result = getNamedParameter("remote-pattern");
        if(required && result == null) {
            bomb("remote-pattern=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPattern() {
		boolean required = false;
        String result = getNamedParameter("pattern");
        if(required && result == null) {
            bomb("pattern=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getPackage() {
		boolean required = false;
        String result = getNamedParameter("package");
        if(required && result == null) {
            bomb("package=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getGenerate();
        getServiceEndpointExtends();
        getServiceEndpointClass();
        getServiceEndpointPattern();
        getServiceEndpointPackage();
        getExtends();
        getLocalClass();
        getLocalExtends();
        getLocalPackage();
        getLocalPattern();
        getRemoteClass();
        getRemotePackage();
        getRemotePattern();
        getPattern();
        getPackage();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}