package org.xdoclet.plugin.ejb.qtags;

public class EjbPermissionTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbPermissionTag {
    public static final String NAME = "ejb.permission";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"method-intf",
		"view-type",
		"unchecked",
		"role-names",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbPermissionTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbPermissionTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getMethodIntf() {
		boolean required = false;
        String result = getNamedParameter("method-intf");
        if(required && result == null) {
            bomb("method-intf=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Remote")|| result.equals("Home")|| result.equals("Local")|| result.equals("LocalHome")|| result.equals("ServiceEndpoint")) ) {
	                // todo we should say what file and line number too
	                bomb("method-intf=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getViewType() {
		boolean required = false;
        String result = getNamedParameter("view-type");
        if(required && result == null) {
            bomb("view-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("local")|| result.equals("remote")|| result.equals("both")|| result.equals("service-endpoint")|| result.equals("remote-service-endpoint")|| result.equals("local-service-endpoint")|| result.equals("all")) ) {
	                // todo we should say what file and line number too
	                bomb("view-type=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isUnchecked() {
		boolean required = false;
        String result = getNamedParameter("unchecked");
        if(required && result == null) {
            bomb("unchecked=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String[] getRoleNames() {
		boolean required = false;
        String result = getNamedParameter("role-names");
        if(required && result == null) {
            bomb("role-names=\"???\" must be specified.");
        }

		java.lang.String[] retVal = null;


		if (result != null) {
			java.util.StringTokenizer strTok = new java.util.StringTokenizer(result, ",");
			retVal = new java.lang.String[strTok.countTokens()];
			int idx = 0;
			String token;
			while (strTok.hasMoreTokens()) {
				token = strTok.nextToken(); 
	            retVal[idx++] = token;
	        }
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getMethodIntf();
        getViewType();
        isUnchecked();
        getRoleNames();
    }

    public void validateModel() {
        // check uniqueness
    }
}