package org.xdoclet.plugin.ejb.qtags;

public class EjbResourceRefTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbResourceRefTag {
    public static final String NAME = "ejb.resource-ref";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"res-auth",
		"res-ref-name",
		"res-sharing-scope",
		"res-type",
		"description",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbResourceRefTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbResourceRefTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getResAuth() {
		boolean required = true;
        String result = getNamedParameter("res-auth");
        if(required && result == null) {
            bomb("res-auth=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("Container")|| result.equals("Application")) ) {
	                // todo we should say what file and line number too
	                bomb("res-auth=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getResRefName() {
		boolean required = false;
        String result = getNamedParameter("res-ref-name");
        if(required && result == null) {
            bomb("res-ref-name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getResSharingScope() {
		boolean required = false;
        String result = getNamedParameter("res-sharing-scope");
        if(required && result == null) {
            bomb("res-sharing-scope=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "Shareable";
        }

		if (result != null) {
	            if( !(false || result.equals("Shareable")|| result.equals("Unshareable")) ) {
	                // todo we should say what file and line number too
	                bomb("res-sharing-scope=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getResType() {
		boolean required = true;
        String result = getNamedParameter("res-type");
        if(required && result == null) {
            bomb("res-type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getDescription() {
		boolean required = false;
        String result = getNamedParameter("description");
        if(required && result == null) {
            bomb("description=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getResAuth();
        getResRefName();
        getResSharingScope();
        getResType();
        getDescription();
    }

    public void validateModel() {
        // check uniqueness
    }
}