package org.xdoclet.plugin.ejb.qtags;

public class EjbUtilTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.ejb.qtags.EjbUtilTag {
    public static final String NAME = "ejb.util";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"generate",
		"lookup-kind",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public EjbUtilTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public EjbUtilTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public boolean isGenerate() {
		boolean required = false;
        String result = getNamedParameter("generate");
        if(required && result == null) {
            bomb("generate=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "true";
        }

		if (result != null) {
	            if( !(false || result.equals("true")|| result.equals("false")) ) {
	                // todo we should say what file and line number too
	                bomb("generate=\"" + result + "\" is an invalid parameter value.");
	            }
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getLookupKind() {
		boolean required = false;
        String result = getNamedParameter("lookup-kind");
        if(required && result == null) {
            bomb("lookup-kind=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "logical";
        }

		if (result != null) {
	            if( !(false || result.equals("logical")|| result.equals("physical")) ) {
	                // todo we should say what file and line number too
	                bomb("lookup-kind=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        if(isOnField) {
            bomb("is not allowed on fields");
        }
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
		if(isOnMethod) {
        	bomb("is not allowed on methods");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        isGenerate();
        getLookupKind();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}